# coding: shift_jis
## ([Deep Leraning@(֓NB )̊֐𗘗pĂ܂)
import numpy as np
import pickle
import collections
class Relu:
    def __init__(self):
        self.mask = None
    def forward(self, x):
        self.mask = (x <= 0)
        out = x.copy()
        out[self.mask] = 0
        return out
    def backward(self, dout):
        dout[self.mask] = 0
        dx = dout
        return dx
class SGD:
    """mIz~@iStochastic Gradient Descentj"""
    def __init__(self, lr=0.01):
        self.lr = lr
        
    def update(self, params, grads):
        for key in params.keys():
            params[key] -= self.lr * grads[key] 
class Adam:
    """Adam (http://arxiv.org/abs/1412.6980v8)"""
    def __init__(self, lr=0.001, beta1=0.9, beta2=0.999):
        self.lr = lr
        self.beta1 = beta1
        self.beta2 = beta2
        self.iter = 0
        self.m = None
        self.v = None
        
    def update(self, params, grads):
        if self.m is None:
            self.m, self.v = {}, {}
            for key, val in params.items():
                self.m[key] = np.zeros_like(val)
                self.v[key] = np.zeros_like(val)
        self.iter += 1
        lr_t  = self.lr * np.sqrt(1.0 - self.beta2**self.iter) / (1.0 - self.beta1**self.iter)         
        
        for key in params.keys():
            self.m[key] += (1 - self.beta1) * (grads[key] - self.m[key])
            self.v[key] += (1 - self.beta2) * (grads[key]**2 - self.v[key])
            
            params[key] -= lr_t * self.m[key] / (np.sqrt(self.v[key]) + 1e-7)
            
class Affine:
    def __init__(self, W, b):
        self.W =W
        self.b = b
        
        self.x = None
        self.original_x_shape = None
        # d݁EoCAXp[^̔
        self.dW = None
        self.db = None
    def forward(self, x):
        # e\Ή
        self.original_x_shape = x.shape
        x = x.reshape(x.shape[0], -1)
        self.x = x
        out = np.dot(self.x, self.W) + self.b
        return out
    def backward(self, dout):
        dx = np.dot(dout, self.W.T)
        self.dW = np.dot(self.x.T, dout)
        self.db = np.sum(dout, axis=0)
        
        dx = dx.reshape(*self.original_x_shape)  # ̓f[^̌`ɖ߂ie\Ήj
        return dx
class Squarederor: #쐬
    def __init__(self):
        self.loss = None
        self.y = None 
        self.t = None # tf[^
    def forward(self, x, t):
        self.t = t
        self.y =x
        batch_size = self.t.shape[0]
        self.loss = 1/2*sum((self.y-self.t)**2)
        
        return self.loss
    def backward(self):
        batch_size = self.t.shape[0]
#        dx = self.y.copy()
        dout=np.clip(self.y-self.t,-1,1) #1
        dx =dout #/ batch_size
       
        return dx
class SimpleNet:
    def __init__(self, input_size=4, 
                 hidden_size=32, output_size=2, weight_init_std=0.02):
        # d݂̏
        self.params = {}
        self.params['W1'] = weight_init_std * \
                            np.random.randn(input_size, hidden_size)
        self.params['b1'] = np.zeros(hidden_size)
        self.params['W2'] = weight_init_std * \
                            np.random.randn(hidden_size, hidden_size)
        self.params['b2'] = np.zeros(hidden_size)
        self.params['W3'] = weight_init_std * \
                            np.random.randn(hidden_size, output_size)
        self.params['b3'] = np.zeros(output_size)
        # C̐
        self.layers = collections.OrderedDict() #o^Ăяo
        self.layers['Affine1'] = Affine(self.params['W1'], self.params['b1'])
        self.layers['Relu1'] = Relu()
        self.layers['Affine2'] = Affine(self.params['W2'], self.params['b2'])
        self.layers['Relu2'] = Relu()
        self.layers['Affine3'] = Affine(self.params['W3'], self.params['b3'])
        self.last_layer = Squarederor() #덷
    def predict(self, x):
        for layer in self.layers.values():
            x = layer.forward(x)
        return x
    def loss(self, x, t):
        """֐߂
        x͓̓f[^At͋tx
        """
        y = self.predict(x)
        return self.last_layer.forward(y, t)
    def gradient(self, x, t):
        """z߂i덷t`@j
        Parameters
        ----------
        x : ̓f[^
        t : tx
        Returns
        -------
        ew̌zfBNViϐ
            grads['W1']Agrads['W2']A...͊ew̏d
            grads['b1']Agrads['b2']A...͊ew̃oCAX
        """
        # forward
        self.loss(x, t)
        # backward
#        dout = 1
        dout = self.last_layer.backward()
        layers = list(self.layers.values())
        layers.reverse()
        for layer in layers:
            dout = layer.backward(dout)
        # ݒ
        grads = {}
        grads['W1'], grads['b1'] = self.layers['Affine1'].dW, self.layers['Affine1'].db
        grads['W2'], grads['b2'] = self.layers['Affine2'].dW, self.layers['Affine2'].db
        grads['W3'], grads['b3'] = self.layers['Affine3'].dW, self.layers['Affine3'].db
        return grads
        
    def save_params(self, file_name=""):
        params = {}
        for key, val in self.params.items():
            params[key] = val
        with open(file_name, 'wb') as f:
            pickle.dump(params, f)
    def load_params(self, file_name=""):
        with open(file_name, 'rb') as f:
            params = pickle.load(f)
        for key, val in params.items():
            self.params[key] = val
        for i, key in enumerate(['Affine1', 'Affine2', 'Affine3']):
            self.layers[key].W = self.params['W' + str(i+1)]
            self.layers[key].b = self.params['b' + str(i+1)]
def paracopy(network,network2): #SimpleNet->SimpleNet2 w bRs[
    
    for i, key in enumerate(['Affine1', 'Affine2', 'Affine3']):
        network2.layers[key].W = network.layers[key].W
        network2.layers[key].b = network.layers[key].b
            
#---------------------------Trainer --------------------------------------
class Trainer:
    """j[lbǧPsNX
    """
    def __init__(self, network,network2,  
                 epochs=20, mini_batch_size=100,
                 optimizer='SGD', optimizer_param={'lr':0.01}, 
                 evaluate_sample_num_per_epoch=None, verbose=True):
        self.network = network
        self.network2 = network2
        self.verbose = verbose
        self.epochs = epochs
        self.batch_size = mini_batch_size
        self.evaluate_sample_num_per_epoch = evaluate_sample_num_per_epoch
        # optimizer
        optimizer_class_dict = {'sgd':SGD, 'adam':Adam}
        self.optimizer = optimizer_class_dict[optimizer.lower()](**optimizer_param)
        
    def train_step(self):
        batch_mask = np.random.choice(self.train_size, self.batch_size)
        x_batch1 = self.x_train1[batch_mask] #݂̏
        x_batch2 = self.x_train2[batch_mask] #̏
        acth = self.t_train[batch_mask] #́@V@I
        t_batch=self.network.predict(x_batch1) #݂̉lǂݍł
        idx=np.arange(len(t_batch))
        nval=self.network.predict(x_batch2) #̉l MAINlbg[N
        c=np.argmax(nval,axis=1) #傫̃CfbNX
        nvalt=self.network2.predict(x_batch2) #̉l TARGETlbg[N2
        mdat=nvalt[idx,c] #̉l TARGETlbg[N2 MAIN傫
        act=((np.sign(acth[:,0])+1)).astype(np.int32) #tb1[,0]͍s E
        ## Iˎ̏Ԗ@mdat=0Ƃ
        mdat=mdat*(1-acth[:,2]) #Ȉꍇ
        gamma=0.95 
        t_batch[idx,act]= (acth[idx,1]+gamma*mdat) #XV鉿l
        grads = self.network.gradient(x_batch1, t_batch)
        self.optimizer.update(self.network.params, grads)
        ## p[^XV
        loss = self.network.loss(x_batch1, t_batch)
        if self.current_iter % 50==0 : print(str(self.current_iter)+ " train loss:" + str(loss))   
        if self.current_iter % self.iter_per_epoch == 0:
            self.current_epoch += 1
        self.current_iter += 1
    def train(self,x_train1,x_train2, t_train):
        self.x_train1 = x_train1
        self.x_train2 = x_train2
        self.t_train = t_train
        self.train_size = x_train1.shape[0]
#        print("self.train_size, self.batch_size, self.epochs",self.train_size, self.batch_size, self.epochs)
        self.iter_per_epoch = max(self.train_size // self.batch_size, 1)
        self.max_iter = int(self.epochs * self.iter_per_epoch)
        self.current_iter = 0
        self.current_epoch = 0
#        print("self.max_iter",self.max_iter)
        for i in range(self.max_iter):
            self.train_step()
            ## SimpleNet->SimpleNet2 w bRs[
#            if i%2==0 :
            paracopy(self.network,self.network2)
